#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include "../ExCommon/TokenID.h"
#include "../ExCommon/GlobalDef.c"
#include "../ExCommon/Funcs.c"
#include "../TeleToken/TeleToken.h"

int main(int argc, char * argv[])
{
    #include "../ExCommon/MainDef.c"

    DWORD   n;
    ZeroMemory(PassTbl,16*PASS_NO);

    #include "../ExCommon/Prolog.c"

    // zainicjowanie OutKey
    OutKey=(GetTickCount()&0xFFFFFF00)|0xF00;

    // zmiana bitw konfiguracji kluczy
    printf("Konfigurowanie bitow kluczy:");

    n=0;
    while(n<TokenInfoTbl[TVTTTI_PASS_TABLE_SIZE])
        {
        ZeroMemory(OutDataA,16);
        ZeroMemory(OutDataB,16);
        ZeroMemory(InDataA,16);
        ZeroMemory(InDataB,16);

        OutKey++;                                                           // zwikszenie licznika kluczy

        OutDataB[TVTTD_CMD]=TVTTC_PASS_SET_CONFIG;                          // rozkaz 
        OutDataB[TVTTD_PARAM1]=(BYTE)n;                                     // numer klucza
        OutDataA[0]=TVTTPC0_PASS_WRITE|TVTTPC0_PASS_CONFIG|TVTTPC0_MEM_READ|TVTTPC0_MEM_WRITE|TVTTPC0_ENCRYPT|TVTTPC0_DECRYPT|TVTTPC0_DECRYPT_WRITE;
		OutDataA[1]=TVTTPC1_CNT_READ|TVTTPC1_CNT_WRITE|TVTTPC1_CNT_CONFIG|TVTTPC1_ENCRYPT_PASS|TVTTPC1_DECRYPT_PASS|TVTTPC1_CNT_ENCRYPT_PASS;

        TVTT_Calc(OutDataA,OutDataB);                                       // policzenie bloku kontrolnego
        TVTT_CryptBlock(OutDataA,OutKey,SessionKey,TVTT_BLOCK_A,TVTT_PC2T); // zaszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(OutDataB,OutKey,SessionKey,TVTT_BLOCK_B,TVTT_PC2T); // zaszyfrowanie drugiego bloku danych
        Status=TVTT_Talk(TokenH,2,OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
        TVTT_CryptBlock(InDataA,InKey,SessionKey,TVTT_BLOCK_A,TVTT_T2PC);   // rozszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(InDataB,InKey,SessionKey,TVTT_BLOCK_B,TVTT_T2PC);   // rozszyfrowanie drugiego bloku danych

        if (Status)
            {
            printf("\t%X:%02X\n",Status>>8,Status&0xFF);
            break;
            };

        if (TVTT_Check(InDataA,InDataB))
            {
            printf("\tBlad bloku kontrolnego!\n");
            break;
            };

        if (InDataB[TVTTD_STATUS])
            {
            printf("\t%X\n",InDataB[TVTTD_STATUS]);
            break;
            }

        if (!InKey)
            {   
            printf("\tWiadomosc nie zaszyfrowana!\n");                      // sprawdzenie czy wiadomo zaszyfrowana
            break;
            };
        n++;
        };

    if (n>=TokenInfoTbl[TVTTTI_PASS_TABLE_SIZE]) printf("\tOK\n");

    #include "../ExCommon/Epilog.c"

    return(0);
};
