#include <string.h>
#include <stdlib.h>
#include <sys/time.h>
#include "../ExCommon/TokenID.h"
#include "../ExCommon/GlobalDef.c"
#include "../ExCommon/Funcs.c"
#include "../TeleToken/TeleToken.h"

int main(int argc, char * argv[])
{
    #include "../ExCommon/MainDef.c"

    DWORD   n;
    ZeroMemory(PassTbl,16*PASS_NO);
    n=0;
    while (n<PASS_NO)
        {
        sprintf((char *) PassTbl+(n*16),"Pass%d",n);
        n++;
        };

    #include "../ExCommon/Prolog.c"

    // zainicjowanie OutKey
    OutKey=(GetTickCount()&0xFFFFFF00)|0xF00;

    // odczyt odczytu ze zwikszeniem licznika TeleTokenu
    printf("Odczyt licznikw TeleTokenu:\n");

    n=0;
    while (n<TokenInfoTbl[TVTTTI_COUNTERS])
        {
        ZeroMemory(OutDataA,16);
        ZeroMemory(OutDataB,16);
        ZeroMemory(InDataA,16);
        ZeroMemory(InDataB,16);

        OutKey++;                                                           // zwikszenie licznika kluczy

        OutDataB[TVTTD_CMD]=TVTTC_CNT_INC_READ;                             // rozkaz zwikszenia i odczytu licznikw TeleTokenu
        OutDataB[TVTTD_PARAM1]=(BYTE)n;                                     // numer licznika

        TVTT_Calc(OutDataA,OutDataB);                                       // policzenie bloku kontrolnego
        TVTT_CryptBlock(OutDataA,OutKey,SessionKey,TVTT_BLOCK_A,TVTT_PC2T); // zaszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(OutDataB,OutKey,SessionKey,TVTT_BLOCK_B,TVTT_PC2T); // zaszyfrowanie drugiego bloku danych
        Status=TVTT_Talk(TokenH,2,OutKey,OutDataA,OutDataB,&InKey,InDataA,InDataB);
        TVTT_CryptBlock(InDataA,InKey,SessionKey,TVTT_BLOCK_A,TVTT_T2PC);   // rozszyfrowanie pierwszego bloku danych
        TVTT_CryptBlock(InDataB,InKey,SessionKey,TVTT_BLOCK_B,TVTT_T2PC);   // rozszyfrowanie drugiego bloku danych

        if (Status)
            {
            printf("\t%X:%02X\n",Status>>8,Status&0xFF);
            break;
            };

        if (TVTT_Check(InDataA,InDataB))
            {
            printf("\tBlad bloku kontrolnego!\n");
            break;
            };

        if (InDataB[TVTTD_STATUS])
            {
            if (InDataB[TVTTD_STATUS]==TVTTS_ACCESS_EXPIRED)                // bd wyzerowanego licznika nie przerywa funkcji
                printf("\t!");
            else
                {
                printf("\t%X\n",InDataB[TVTTD_STATUS]);
                break;
                };
            }

        if (!InKey)
            {   
            printf("\tWiadomosc nie zaszyfrowana!\n");                      // sprawdzenie czy wiadomo zaszyfrowana
            break;
            };

        printf("\t%02X: %02X%02X\n",n,InDataA[1],InDataA[0]);;
        n++;
        };
    if (n==TokenInfoTbl[TVTTTI_COUNTERS]) printf("\tOK\n");

    #include "../ExCommon/Epilog.c"

    return(0);
};
